<?php
/**
 * @version		3.4.0 components/com_buttons/views/category/view.html.php
 * 
 * @package		Buttons
 * @subpackage	com_buttons
 * @since		3.4
 *
 * @author		Helios Ciancio <info@eshiol.it>
 * @link		http://www.eshiol.it
 * @copyright	Copyright (C) 2015 Helios Ciancio. All Rights Reserved
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL v3
 * Buttons is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access.');

use Joomla\Registry\Registry;

/**
 * HTML View class for the buttons component
 */
class ButtonsViewCategory extends JViewCategory
{
	/**
	 * Execute and display a template script.
	 *
	 * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
	 *
	 * @return  mixed  A string if successful, otherwise a Error object.
	 */
	public function display($tpl = null)
	{
		parent::commonCategoryDisplay();

		$user = JFactory::getUser();
		$db    = JFactory::getDbo();
		
		$jinput = JFactory::getApplication()->input;
		$this->catid = $jinput->get('id');
		
		$content = JTable::getInstance('Content');
		$content->load($jinput->get('article_id'));
		$this->asset_id = $content->get('asset_id');

		$categories = JCategories::getInstance('Buttons');
		$category = $categories->get($this->catid);
		$cparams = new Registry;
		$cparams->loadString($category->params);
		$this->toolbar_type = $cparams->get('toolbar_type');

		$this->toolbar_final = ($cparams->get('toolbar_final',0) &&
			(2 == (int)$db->setQuery(
				$db->getQuery(true)
				->select($db->qn('state'))
				->from($db->qn('#__buttons_extras'))
				->where($db->qn('catid').' = '.$this->catid)
				->where($db->qn('editor_user_id').' = '.$user->id)
				->where($db->qn('asset_id').' = '.$this->asset_id)
				)->loadResult())
			);

		$value = (int)$db->setQuery(
			$db->getQuery(true)
			->select($db->qn('value'))
		 	->from($db->qn('#__buttons_extras'))
		 	->where($db->qn('editor_user_id').' = '.$user->id)
		 	->where($db->qn('asset_id').'='.$this->asset_id)
			)->loadResult()
			;

		// Prepare the data.
		// Compute the button slug & link url.
		foreach ($this->items as $item)
		{
			$item->value = pow(2, ($item->value-1)) & $value;

			$item->catid=$this->catid;
			$item->asset_id=$this->asset_id;
			$item->toolbar_type=$this->toolbar_type;
			$item->toolbar_final=$this->toolbar_final;
			
			$temp = $item->images;
			$item->images = new Registry;
			$item->images->loadString($temp, 'JSON');
/*
			$temp = new JRegistry;
			$temp->loadString($item->params);
			$item->params = clone($this->params);
			$item->params->merge($temp);
*/
		}

		return parent::display($tpl);
	}
}
